The OpenNET Project / Index page

[ новости /+++ | форум | wiki | теги | ]

Выпуски libssh2 1.8.1 и Putty 0.71 с устранением уязвимостей

21.03.2019 20:22

Доступен новый выпуск SSH-клиента PuTTY 0.71, в котором устранены восемь уязвимостей. Некоторые проблемы выявлены участниками инициативы FOSSA (Free and Open Source Software Audit), выплачивающей вознаграждение за обнаружение уязвимостей в ключевых открытых проектах, применяемых в госучреждениях Евросоюза.

  • Первая уязвимость позволяет организатору MITM-атаки обойти проверку DSA и получить доступ сеансу пользователя (просматривать и вносить изменения в сеансы), в случае использования ключей в формате DSA ("ssh-dss"). Уязвимость возникла в процессе переработки криптографического стека, но к счастью присутствовала только в экспериментальной ветке Putty и была выявлена до публикации релиза.
  • Вторая уязвимость выявлена в реализации протокола обмена ключами RSA и может привести к целочисленному переполнению при первом обращении к серверу, к которому ранее не выполнялись подключения. Проблема потенциально выполнить код при подключении к серверу. Проблема проявляется на стадии до верификации, т.е. система может быть атакована через проведение MITM-атаки без непосредственной компрометации сервера. При этом атака возможна только для серверов, ключ хоста которых ещё не аутентифицирован;
  • Третья проблема проявляется после установки соединения и инициируется через создание сервером слишком большого числа перенаправлений портов. В случае успешной атаки возможно переполнение буфера и выполнение кода при подключении к вредоносному серверу.
  • Четвёртая уязвимость специфична для Windows и проявляется при размещении файла putty.chm атакующего в каталоге, в котором запускается PuTTY (при обработке подставного файла с помощью возможно выполнение кода через манипуляции с тегом OBJECT).
  • Серия уязвимостей позволяющих вызвать отказ в обслуживании (крах PuTTY или потребление значительных ресурсов памяти и CPU) или исказить вывод при запуске на сервере в рамках установленного сеанса приложений, выводящих определённые последовательности в терминал.

В новом выпуске PuTTY также предпринято несколько мер по повышению безопасности:

  • Код, связанный с криптографией, переписан для защиты от атак по сторонним каналам;
  • Для блокирования подставных фиктивных запросов паролей визуально разделены запросы аутентификации PuTTY и вывод в терминале сообщений сервера;
  • Для защиты от атак через подстановку спецсимволов реализована чистка управляющих символов при копировании данных через буфер обмена, вывода в терминал и обработке имён файлов.

Из не связанных с безопасностью изменений можно отметить:

  • Добавлена поддержка запуска интерфейса PuTTY с использованием GTK поверх протокола Wayland;
  • Улучшена работа на экранах high-DPI;
  • Добавлены реализации AES, SHA-256 и SHA-1, использующие предоставляемые процессорами ARM и X86 инструкции для аппаратного ускорения криптографических операций.
  • Добавлена поддержка полноцветного вывода (True Color) в терминалах с использованием управляющих последовательностей SGR 2.
  • Приглашения аутентификации теперь могут содержать символы, не ограниченные кодировкой US-ASCII.
  • Добавлена поддержка аутентификации в Kerberos через GSSAPI.
  • Улучшена работа с буфером обмена, в том числе появилась опция для и автоматического помещения текста в буфер обмена сразу после его выделения и возможность работы с несколькими буферами обмена.
  • Добавлены новые горячие клавиши Ctrl+Shift+PgUp и Ctrl+Shift+PgDn для перехода к верхней и нижней частям истории прокрутки.

Также состоялся новый выпуск библиотеки libssh2 1.8.1, предлагающей реализацию протокола SSH2 для интеграции функций SSH-клиента в произвольные приложения, в котором устранено 9 уязвимостей. Четыре проблемы позволяют организовать запись за пределы выделенного буфера и потенциально выполнить код злоумышленника в контексте клиентского приложения при обработке специально оформленных данных, поступающих при подключении к серверу, подконтрольному атакующему.

  1. Главная ссылка к новости (https://lists.tartarus.org/pip...)
  2. OpenNews: Уязвимости в реализациях SCP из OpenSSH, PuTTY и WinSCP
  3. OpenNews: Новый выпуск SSH-клиента PuTTY 0.68
  4. OpenNews: Ещё одна уязвимость в OpenSSH, позволяющая определить наличие пользователей
  5. OpenNews: Критическая уязвимость в библиотеке Libssh
  6. OpenNews: Выявлен 21 вид вредоносных программ, подменяющих OpenSSH
Лицензия: CC-BY
Тип: Программы
Ключевые слова: libssh, ssh, putty
При перепечатке указание ссылки на opennet.ru обязательно
Обсуждение (12) Ajax | 1 уровень | Линейный | Раскрыть всё | RSS
  • 1.1, Stax (ok), 20:37, 21/03/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • –1 +/
    Долго они! О дырах писали 2 месяца назад (https://www.opennet.ru/opennews/art.shtml?num=49953), и два месяца ни багфикс-релизов, ничего не было...
     
     
  • 2.16, Michael Shigorin (ok), 22:41, 22/03/2019 [^] [^^] [^^^] [ответить]  
  • –1 +/
    Как минимум putty 0.70 ещё и не собирался gcc8.
     

  • 1.2, Аноним (2), 21:16, 21/03/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • +1 +/
    Прикольно, переписали криптостек чтобы защититься от гипотетических утечек следов работы через кэш, а получили знаковую дыру, позволяющую сниффить и менять трафик.
     
     
  • 2.12, пох (?), 07:16, 22/03/2019 [^] [^^] [^^^] [ответить]  
  • +1 +/
    дык, что вас удивляет - оно всегда так. Улучшайки они такие улучшайки... особенно в крипто, с которым у putty традиционно всегда было плохо.

    справедливости ради - dss auth в современных sshd уже и включить-то без танцев с бубном не получится, скоро, небось, совсем доломают.

     

  • 1.4, Гогге (?), 23:46, 21/03/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • –1 +/
    В нём можно настройки не в реестре хранить?
     
     
  • 2.6, YetAnotherOnanym (ok), 00:29, 22/03/2019 [^] [^^] [^^^] [ответить]  
  • –1 +/
    Вроде бы сборка от PortableApps так делает.
     

  • 1.5, Аноним (5), 00:20, 22/03/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • –2 +/
    > Putty

    Но сам BSD-то вне опасности? Под ударом только Windows-системы BSD-пользователей?

     
     
  • 2.10, анонн (?), 02:22, 22/03/2019 [^] [^^] [^^^] [ответить]  
  • +2 +/
    >> Putty
    > Но сам BSD-то вне опасности? Под ударом только Windows-системы BSD-пользователей?

    [code]
    pkg search putty
    gputty-0.9.10                  Frontend to the SSH client, using the Gtk+ toolkit
    putty-0.71                     Secure shell and telnet client
    putty-gtk2-0.71                Secure shell and telnet client
    putty-nogtk-0.71               Secure shell and telnet client
    [/code]
    Можешь спать спокойно! Если конечно не убунтуйщик:
    https://repology.org/project/putty/versions
    [code]
    Ubuntu 18.10
    cosmic/universe putty 0.70 universe/net
    Ubuntu 19.04
    disco/universe putty 0.70 universe/net
    [/code]
    хотя да, оно им не надо - у них есть WSL.

     
  • 2.14, Ключевский (?), 10:18, 22/03/2019 [^] [^^] [^^^] [ответить]  
  • –2 +/
    Обновили единственный используемый пользователями *BSD DE, так что надо радоваться за пользователей *BSD, у них праздник.
     
     
  • 3.17, _ (??), 05:09, 23/03/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Не надо уж _ТАК_ завидовать 8-)
     

  • 1.11, policy (?), 06:45, 22/03/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • +3 +/
    > Добавлена поддержка аутентификации в Kerberos через GSSAPI.

    Нет же, добавлена поддежрка GSSAPI Key Exchange, аутентификацию он умел давно.

    Поддержку GSSAPI Kex заметят только те, кто использует делегирование, так как теперь при обновлении локальных тикетов, они будут обновляться в подключенных сессиях.

     
  • 1.15, hiveliberty (ok), 12:54, 22/03/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • –1 +/
    > автоматического помещения текста в буфер обмена сразу после его выделения

    Странно, сколько пользуюсь putty, но там всегда была эта фича.
    По крайне мере, в версиях 0.6x-0.7x

     

     Добавить комментарий
    Имя:
    E-Mail:
    Текст:



    Спонсоры:
    Слёрм
    Inferno Solutions
    Hosting by Ihor
    Хостинг:

    Закладки на сайте
    Проследить за страницей
    Created 1996-2019 by Maxim Chirkov
    Добавить, Поддержать, Вебмастеру